diff --git a/EmojicodeReal-TimeEngine/EmojicodeString.c b/EmojicodeReal-TimeEngine/EmojicodeString.c
index 66342b1b..2153c5e0 100644
--- a/EmojicodeReal-TimeEngine/EmojicodeString.c
+++ b/EmojicodeReal-TimeEngine/EmojicodeString.c
@@ -367,7 +367,7 @@ static void stringFromSymbolListBridge(Thread *thread){
     initStringFromSymbolList(stackGetThis(thread), stackGetVariable(0, thread).object->value);
 }
 
-static void stringFromStringList(Thread *thread){
+static void stringFromStringList(Thread *thread) {
     size_t stringSize = 0;
     size_t appendLocation = 0;
     
@@ -375,8 +375,12 @@ static void stringFromStringList(Thread *thread){
         List *list = stackGetVariable(0, thread).object->value;
         String *glue = stackGetVariable(1, thread).object->value;
         
-        for(size_t i = 0; i < list->count; i++){
-            stringSize += ((String *)listGet(list, i).object->value)->length - 1 + glue->length;
+        for (size_t i = 0; i < list->count; i++) {
+            stringSize += ((String *)listGet(list, i).object->value)->length;
+        }
+        
+        if (list->count > 0){
+            stringSize += glue->length * (list->count - 1);
         }
     }
         
@@ -390,13 +394,13 @@ static void stringFromStringList(Thread *thread){
         string->length = stringSize;
         string->characters = co;
         
-        for(size_t i = 0; i < list->count; i++){
+        for (size_t i = 0; i < list->count; i++) {
             String *aString = listGet(list, i).object->value;
-            memcpy(characters(string) + appendLocation, characters(aString), (aString->length - 1) * sizeof(EmojicodeChar));
-            appendLocation += aString->length - 1;
+            memcpy(characters(string) + appendLocation, characters(aString), aString->length * sizeof(EmojicodeChar));
+            appendLocation += aString->length;
             if(i + 1 < list->count){
-                memcpy(characters(string) + appendLocation, characters(glue), (glue->length - 1) * sizeof(EmojicodeChar));
-                appendLocation += glue->length - 1;
+                memcpy(characters(string) + appendLocation, characters(glue), glue->length * sizeof(EmojicodeChar));
+                appendLocation += glue->length;
             }
         }
     }
diff --git a/tests/stringTest.emojic b/tests/stringTest.emojic
index da008d1b..3a5ca0b9 100755
--- a/tests/stringTest.emojic
+++ b/tests/stringTest.emojic
@@ -56,6 +56,11 @@
     ⛔️🐕 😛 📝 🔤🔤 🔟h 🔤h🔤 🔤Symbol add empty🔤
     ⛔️🐕 😛 📝 🔤10🔤 🔟€ 🔤10€🔤 🔤Symbol add €🔤
 
+    ⛔️🐕 😛🔷🔡🍨 🍨🔤123🔤 🔤dang🔤 🔤oh_man🔤🍆 🔤--🔤 🔤123--dang--oh_man🔤 🔤Join 2 symbols🔤
+    ⛔️🐕 😛🔷🔡🍨 🍨🔤123🔤 🔤dang🔤 🔤oh_man🔤🍆 🔤🔤 🔤123dangoh_man🔤 🔤Join empty seperator🔤
+    ⛔️🐕 😛🔷🔡🍨 🍨🔤123🔤 🔤dang🔤 🔤oh_man🔤🍆 🔤-🔤 🔤123-dang-oh_man🔤 🔤Join 1 symbol🔤
+    ⛔️🐕 😛🔷🔡🍨 🔷🍨🐚🔡🐸 🔤1234567🔤 🔤🔤 🔤Join empty input🔤
+
     ⛔️🐕 😛 🔷🔡🚂 342 10 🔤342🔤 🔤342 to stirng🔤
     ⛔️🐕 😛 🔷🔡🚂 0x28 16 🔤28🔤 🔤0x28 to stirng🔤
     ⛔️🐕 😛 🔷🔡🚂 010 8 🔤10🔤 🔤010 to stirng🔤
